// Dmitry _kun_ Sayutin (2019)

#include <bits/stdc++.h>

using std::cin;
using std::cout;
using std::cerr;

using std::vector;
using std::map;
using std::array;
using std::set;
using std::string;

using std::pair;
using std::make_pair;

using std::tuple;
using std::make_tuple;
using std::get;

using std::min;
using std::abs;
using std::max;
using std::swap;

using std::unique;
using std::sort;
using std::generate;
using std::reverse;
using std::min_element;
using std::max_element;

#ifdef LOCAL
#define LASSERT(X) assert(X)
#else
#define LASSERT(X) {}
#endif

template <typename T>
T input() {
    T res;
    cin >> res;
    LASSERT(cin);
    return res;
}

template <typename IT>
void input_seq(IT b, IT e) {
    std::generate(b, e, input<typename std::remove_reference<decltype(*b)>::type>);
}

#define SZ(vec)         int((vec).size())
#define ALL(data)       data.begin(),data.end()
#define RALL(data)      data.rbegin(),data.rend()
#define TYPEMAX(type)   std::numeric_limits<type>::max()
#define TYPEMIN(type)   std::numeric_limits<type>::min()

struct node {
    node() {
        std::fill(go, go + 26, (node*)NULL);
    }

    int cnt = 0;
    int L = TYPEMAX(int);
    int R = TYPEMIN(int);
    
    bool term = false;
    node* go[26];
    node* par = NULL;
    int num_ch = 0;

    int up_edge_count = 0;
    
    bool is_kek() {
        return term or num_ch >= 2;
    }
};

int main() {
    std::iostream::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    // code here
    int q = input<int>();

    vector<pair<string, int>> strings;

    vector<pair<int, int>> op(q);

    for (int i = 0; i != q; ++i) {
        char ch = input<char>();
        if (ch == '+') {
            strings.emplace_back(input<string>(), -1);
            
            op[i].first = +1;
            op[i].second = SZ(strings) - 1;
        } else {
            op[i].first = (ch == '?' ? 0 : -1);
            op[i].second = input<int>() - 1;
        }
    }

    for (int i = 0; i != SZ(strings); ++i)
        strings[i].second = i;

    sort(ALL(strings));

    node* root = new node();
    
    vector<int> where(SZ(strings), -1);
    for (int i = 0; i != SZ(strings); ++i)
        where[strings[i].second] = i;

    for (auto& x: op)
        x.second = where[x.second];
    
    for (int i = 0; i != SZ(strings); ++i) {
        node* cur = root;
        cur->L = min(cur->L, i);
        cur->R = max(cur->R, i);
        
        for (char ch: strings[i].first) {
            if (cur->go[ch - 'a'] == NULL) {
                cur->go[ch - 'a'] = new node();
                cur->go[ch - 'a']->par = cur;
            }

            cur = cur->go[ch - 'a'];
            cur->L = min(cur->L, i);
            cur->R = max(cur->R, i);
        }
    }

    vector<int> rsq(SZ(strings) + 1);
    auto sum = [&](int r) {
        int res = 0;
        // for (; r >= 0; --r)
        //     res += rsq[r];
        for (; r >= 0; r = (r & (r + 1)) - 1)
            res += rsq[r];
        return res;
    };

    auto incr = [&](int i, int x) {
        //rsq[i] += x;
        for (; i < SZ(rsq); i = i | (i + 1))
            rsq[i] += x;
    };

    root->num_ch += 100; // make root kek for sure

    auto trigger = [&](node* nd, bool was_kek, bool now_kek) {
        if (was_kek == now_kek)
            return;

        int delta = (now_kek ? +1 : -1);
        for (node* v: {nd, nd->par})
            if (v != NULL) {
                if (v->par == NULL) // haha, edge up
                    break;
                
                v->up_edge_count += delta;

                if (v->up_edge_count == 0) {
                    incr(v->L, -1);
                    incr(v->R + 1, +1);
                }
                
                if (v->up_edge_count == 1 and delta > 0) {
                    incr(v->L, +1);
                    incr(v->R + 1, -1);
                }
            }
    };
    
    std::function<void(node*, const char*, int)> add = [&](node* nd, const char* s, int x) {
        if (*s == 0) {
            bool was_kek = nd->is_kek();
            
            nd->term = (x > 0);
            nd->cnt += x;

            bool now_kek = nd->is_kek();

            trigger(nd, was_kek, now_kek);
        } else {
            bool was_kek = nd->is_kek();
            
            node* chch = nd->go[*s - 'a'];
 
            nd->cnt += x;
            nd->num_ch -= (chch->cnt > 0);
            add(chch, s + 1, x);
            nd->num_ch += (chch->cnt > 0);

            bool now_kek = nd->is_kek();

            trigger(nd, was_kek, now_kek);
         }
    };
    
    for (auto& qq: op) {
        if (qq.first == -1 or qq.first == +1) {
            add(root, strings[qq.second].first.c_str(), qq.first);
        } else {
            int ans = sum(qq.second);

            const char* s = strings[qq.second].first.c_str();
            
            if (root->num_ch - 100 == 1 and not root->go[*s - 'a']->is_kek())
                --ans; // no need to press the first key
            
            cout << ans << "\n";
        }
    }
    
    return 0;
}
