import random
import math
random.seed("personal02/universes")

class TestGen:
    def __init__(self):
        self.test_number = 0

    def generate_samples(self):
        print('Generating samples...')
        self.print_test(2, 11, [3, 2, 6, 10])
        self.print_test(4, 11, [3, 2, 6, 10])

    def generate_hand_tests(self):
        self.print_test(0, 0, [1])
        self.print_test(0, 0, [10**4])
        self.print_test(0, 1, [1])
        self.print_test(0, 1, [2])
        self.print_test(0, 1, [3])
        self.print_test(1, 1, [2])
        self.print_test(3, 4, [4])
        self.print_test(1, 3, [1, 2, 4])

    def generate_max_tests(self, maxn):
        pass

    def generate_random_test(self, n, maxv):
        a = random.randint(0, maxv)
        a0 = a
        num = []
        x = random.randint(1, min(n, 100))
        for i in range(x):
            nx = random.randint(1, maxv)
            a |= nx
            num.append(nx)
        for i in range(n - x):
            num.append(random.randint(1, maxv))
        random.shuffle(num)
        self.print_test(a0, a, num)

    def generate_random_no_answer_test(self, n, maxv):
        p = 0
        while 2**p <= maxv:
            p += 1
        p -= 1
        if random.randint(1, 4) == 1:
            num = [random.randint(1, maxv) for _ in range(n)]
            a = random.randint(1, maxv)
            bits = []
            for i in range(p):
                if (a and (1 << i)) > 0:
                    bits.append(i)
            bit = bits[random.randint(0, len(bits) - 1)]
            b = (a ^ (1 << bit))
            self.print_test(a, b, num)
        else:
            if n > 100:
                a = random.randint(0, maxv)
                a0 = a
                num = []
                x = random.randint(101, n)
                for i in range(x):
                    nx = random.randint(1, maxv)
                    a |= nx
                    num.append(nx)
                for i in range(n - x):
                    num.append(random.randint(1, maxv))
                random.shuffle(num)
                self.print_test(a0, a, num)
            else:
                a = random.randint(0, maxv)
                b = a
                bits = []
                for i in range(p):
                    if ((a & (1 << i)) == 0) and random.randint(1, 2) == 1:
                        b |= (1 << i)
                        bits.append(i)

                bit = bits[random.randint(0, len(bits) - 1)]
                nums = []
                for i in range(n):
                    x = random.randint(1, maxv)
                    while (x & (1 << bit)) > 0:
                        x = random.randint(1, maxv)
                    nums.append(x)
                self.print_test(a, b, nums)

    def generate_subtask1(self):
        print('Generating subtask1...')
        self.generate_hand_tests()
        for n in [3, 5, 10, 15, 20]:
            for maxv in [10, 100, 1000, 2**13]:
                self.generate_random_test(n, maxv)
            for i in range(2):
                self.generate_random_no_answer_test(n, 2**13)

    def generate_subtask2(self):
        print('Generating subtask2...')
        for n in [50, 100, 1000, 10**4]:
            for maxv in [10, 100, 10**3, 2**13]:
                self.generate_random_test(n, maxv)
            for i in range(2):
                self.generate_random_no_answer_test(n, 2**13 - 1)
        num = []
        for i in range(0, 14):
            num.append(2**i)
        for i in range(10**4 - 14):
            num.append(239)
        random.shuffle(num)
        self.print_test(0, 2**13 - 1, num)

        num = []
        for i in range(13):
            num.append(1 << i)
        self.print_test(0, 2**13 - 1, num)
        num = []
        for i in range(10**4):
            num.append(1 << random.randint(0, 13))
        self.print_test(0, 2**13 - 1, num)        

    def generate_subtask3(self):
        print('Generating subtask3...')
        for n in [10**4, 10**5]:
            for maxv in [10**5, 2**29]:
                self.generate_random_test(n, maxv)
            for i in range(2):
                self.generate_random_no_answer_test(n, 2**29)
        num = []
        for i in range(0, 30):
            num.append(2**i)
        for i in range(10**5 - 30):
            num.append(10**9)
        random.shuffle(num)
        self.print_test(0, 2**29 - 1, num)
        num = []
        for i in range(0, 29):
            num.append(2**i)
        for i in range(10**5 - 29):
            num.append(10**9)
        random.shuffle(num)
        self.print_test(0, 2**29 - 1, num)
        self.print_test(10**9, 10**9, num)

        p = random.randint(1, 29)
        num = []
        for i in range(10**5):
            x = random.randint(0, 29)
            while x == p:
                x = random.randint(0, 29)
            pw = (1 << x)
            y = random.randint(0, max(0, x - 1))
            while y == p:
                y = random.randint(0, x - 1)
            pw += (1 << y)
            num.append(pw)
        self.print_test(0, 2**29 - 1, num)
        num = []
        for i in range(10**5):
            x = random.randint(0, 29)
            pw = (1 << x)
            y = random.randint(0, max(0, x - 1  ))
            pw += (1 << y)
            num.append(pw)
        self.print_test(0, 2**29 - 1, num)

        num = []
        for i in range(29):
            num.append(1 << i)
        self.print_test(0, 2**29 - 1, num)        
        num = []
        for i in range(10**5):
            num.append(1 << random.randint(0, 29))
        self.print_test(0, 2**29 - 1, num)        
            
    def print_test(self, a, b, num):
        self.test_number += 1
        print('Generating test #%d' % self.test_number)
        test_name = "{0:0=2d}".format(self.test_number)
        test_file = open(test_name, 'w')
        print(len(num), a, b, file=test_file)
        print(' '.join(map(str, num)), file=test_file)
        test_file.close()

    def generate_all_tests(self):
        self.generate_samples()

        self.generate_subtask1()
        self.generate_subtask2()
        self.generate_subtask3()

import time
start = time.time()
writer = TestGen()
writer.generate_all_tests()
finish = time.time()
print('All tests were generated. Elapsed time: ', finish - start)
